%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  30. fixcom.m  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function y=fixcom(x,a)
%   Returns, if possible, a mulprec number (or mulprec vector)
%  with the same fixed comma representation as the normalized mulprec
% number  a , i.e., with the same exponent and size
% as the mulprec number a .
% If impossible, an error message is given.
% Very preliminary.
%
  lea=length(a); dix=size(x,1); yp=zeros(dix,lea);
  if all( (x(:,1)==a(1)) & (dix==lea) ), return, end
  % Out, because the components of x are already of the same fixed comma
  % shape as  a .
  %
  for i=1:dix,
    z=nize(x(i,:));
    if a(1)+lea<z(1)+length(z(i)),
      dix, i,
      disp('x_i ='), disp(x(i,1:5)), disp('...')
      disp('a ='),disp(a(1:5)), disp('...')
      error('The fixcom requirements for are not satisfied by x_i or x.')
    end
  end
  %
  for i=1:dix,
    lez=length(z(i));    % yp(i,:)=zeros();
    k=a(1)+lea-(z(1)+lez-2);
    %
    if k>lea, yp(i,:)=zeros(1,lea);
    elseif k<2+lea-lez, yp(i,k:lez+k-2)=z(i,:);
    elseif k>=2+lea-lez,yp(i,k:lea)=z(i,2:2+lea-k);
    %      k<2 leads to the err.cond. treated above.
    end  %if
  end    %for
  %
  y=yp;
