function z=mul(x,y,s);    % Version 2.
% z becomes the product of two mulprec numbers x,y.
% One or both factors may be floats; z becomes (equivalent
% to) a normalized s gyte mulprec.
%   If the opional argument  s is not given, the function
% returns the normalized full length product.
% Test that the algorithm is valid for complex factors !!

if(((length(x)==1)&(x==0))|((length(y)==1)&(y==0))),
   z=[0,0]; return,          end %if x or y is a zero float
if length(y)==1, y=npc(y);   end % if y is a float
if length(x)==1, x=npc(x);   end % if x is a float
if any(x(2:length(x)))*any(y(2:length(y)))==0,
   z=[0,0];                 % shortcut if a factor is zero.
   return
end
%
x=nize(x); y=nize(y);
if length(x)<length(y),
  % Let the shorter factor become the multiplier y.
  tmp=x; x=y; y=tmp;
end

if length(y)>90, % This must be changed, when a function for
   y=chop(y,90); % longer multipliers has been developed.
                 % Note that  2^53 approx 90*10^14.
   disp('The multiplier is chopped to 90 gytes in order to avoid overflow.')
end
%
lex=length(x); ley=length(y);
%
if nargin==2, u=x(2:lex);  m=x(1)+y(1);
%
   % Now comes a loop for exact multiplication:
   % y is the multiplier; u is the multiplicand.
   zp=[m, y(ley)*u ];
   for j=1:ley-2,
     term=y(ley-j)*u;
     zp=add(zp, [m+j,term]);
   end
   z=nize(zp); return
%
else tmp=chop(x,s+2); u=tmp(2:s+2);     % (now nargin==3)
         % lex=length(x), s, y1=y(1), x1=x(1), tmp1=tmp(1) %temporary
   m= x(1)+lex-s-2+y(1)+ley-2;

   % Now comes a loop for multiplication with internal chopping:
   % y is the multiplier; u is the multiplicand. One more gyte makes
   % "a giant guarding figure".

   zp=zeros(1,s+1);
   for j=1:min(s+1, ley-1)
      zp(j:s+1)=zp(j:s+1) + y(j+1)*u(1:s-j+2);
   end
  %
   z=nize([m,zp]);
   if length(z)>s,
       z=chop(z,s);
   end
end
